VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsMenuItem"
Attribute VB_Ext_KEY = "Member0" ,"clsMenuItem"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private mIndex As Long

' Menu flags for Add/Check/EnableMenuItem()
Private Const MF_SEPARATOR = &H800&
Private Const MF_ENABLED = &H0&
Private Const MF_GRAYED = &H1&
Private Const MF_DISABLED = &H2&
Private Const MF_UNCHECKED = &H0&
Private Const MF_CHECKED = &H8&
Private Const MF_USECHECKBITMAPS = &H200&
Private Const MF_STRING = &H0&
Private Const MF_BITMAP = &H4&
Private Const MF_OWNERDRAW = &H100&
Private Const MF_POPUP = &H10&
Private Const MF_MENUBARBREAK = &H20&
Private Const MF_MENUBREAK = &H40&
Private Const MF_UNHILITE = &H0&
Private Const MF_HILITE = &H80&
Private Const MF_DEFAULT = &H1000&
Private Const MF_SYSMENU = &H2000&
Private Const MF_HELP = &H4000&
Private Const MF_RIGHTJUSTIFY = &H4000&

Private Const MFT_STRING = MF_STRING
Private Const MFT_BITMAP = MF_BITMAP
Private Const MFT_MENUBARBREAK = MF_MENUBARBREAK
Private Const MFT_MENUBREAK = MF_MENUBREAK
Private Const MFT_OWNERDRAW = MF_OWNERDRAW
Private Const MFT_RADIOCHECK = &H200&
Private Const MFT_SEPARATOR = MF_SEPARATOR
Private Const MFT_RIGHTORDER = &H2000&
Private Const MFT_RIGHTJUSTIFY = MF_RIGHTJUSTIFY

'/* Menu flags for Add/Check/EnableMenuItem() */
Private Const MFS_GRAYED = &H3&
Private Const MFS_DISABLED = MFS_GRAYED
Private Const MFS_CHECKED = MF_CHECKED
Private Const MFS_HILITE = MF_HILITE
Private Const MFS_ENABLED = MF_ENABLED
Private Const MFS_UNCHECKED = MF_UNCHECKED
Private Const MFS_UNHILITE = MF_UNHILITE
Private Const MFS_DEFAULT = MF_DEFAULT

Private Const MIIM_STATE = &H1
Private Const MIIM_ID = &H2
Private Const MIIM_SUBMENU = &H4
Private Const MIIM_CHECKMARKS = &H8
Private Const MIIM_TYPE = &H10
Private Const MIIM_DATA = &H20
Private Const MIIM_STRING = &H40
Private Const MIIM_BITMAP = &H80
Private Const MIIM_FTYPE = &H100

Private Const TPM_RIGHTBUTTON = &H2&
Private Const TPM_CENTERALIGN = &H4&
Private Const TPM_LEFTALIGN = &H0&
Private Const TPM_LEFTBUTTON = &H0&
Private Const TPM_RIGHTALIGN = &H8&
Private Const TPM_RETURNCMD = &H100&

Private Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Private Declare Function TrackPopupMenu Lib "user32" ( _
    ByVal Hmenu As Long, _
    ByVal wFlags As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    ByVal nReserved As Long, _
    ByVal hwnd As Long, _
    lprc As Long _
) As Long

Private Declare Function CreatePopupMenu Lib "user32" ( _
) As Long

Private Declare Function InsertMenu Lib "user32" Alias "InsertMenuA" ( _
    ByVal Hmenu As Long, _
    ByVal nPosition As Long, _
    ByVal wFlags As Long, _
    ByVal wIDNewItem As Long, _
    ByVal lpNewItem As Any _
) As Long

Private Declare Function InsertMenuItem Lib "user32" Alias "InsertMenuItemA" ( _
    ByVal Hmenu As Long, _
    ByVal un As Long, _
    ByVal bool As Boolean, _
    ByRef lpcMenuItemInfo As MENUITEMINFO _
) As Long

Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" ( _
    ByVal Hmenu As Long, _
    ByVal wFlags As Long, _
    ByVal wIDNewItem As Long, _
    ByVal lpNewItem As Any _
) As Long

Private Declare Function DestroyMenu Lib "user32" ( _
    ByVal Hmenu As Long _
) As Long

Private Declare Function DrawMenuBar Lib "user32" ( _
    ByVal hwnd As Long _
) As Long

Public Function ShowMenu(hwnd As Long, X As Long, Y As Long) As Integer
Dim myItem As clsMenuItem
Dim Info As MENUITEMINFO
Dim Hmenu As Long

'first create the menu
    Hmenu = CreatePopupMenu
    Info.cbSize = LenB(Info)
    
'add each item from our collection of menu items
    For Each myItem In mCol
        
        'Menu item type
        If myItem.isSeparator Then
            Info.fMask = MIIM_FTYPE
            Info.fType = MFT_SEPARATOR
        Else
            'Members to retrieve or set
            Info.fMask = MIIM_FTYPE Or MIIM_STATE Or MIIM_STRING Or MIIM_ID
            Info.fType = MFT_STRING
        
            'Menu item state.
            If myItem.Checked Then
                Info.fState = MFS_CHECKED
            Else
                Info.fState = MFS_UNCHECKED
            End If
            If myItem.Enabled Then
                Info.fState = Info.fState Or MFS_ENABLED
            Else
                Info.fState = Info.fState Or MFS_DISABLED
            End If
            
            'menu item ID number
            Info.wID = myItem.ID
            
            'caption
            Info.dwTypeData = myItem.Caption
            Info.cch = Len(myItem.Caption)
        End If
        InsertMenuItem Hmenu, myItem.Position, 1, Info
    Next
    
'now show it
        'TPM_RETURNCMD - have function return ID to selected item menu
        'TPM_RIGHTBUTTON - allow user to use right button too
        'TPM_LEFTALIGN - position on left edge of menu
        ShowMenu = TrackPopupMenu(Hmenu, TPM_LEFTALIGN Or TPM_RIGHTBUTTON Or TPM_RETURNCMD, X, Y, 0&, hwnd, ByVal 0&)

'cleanup
        DestroyMenu Hmenu

End Function

Public Function Add(Caption As String, Optional ID As Long) As clsMenuItem
    'create a new object
    Dim objNewMember As clsMenuItem
    Set objNewMember = New clsMenuItem

    mIndex = mIndex + 1
    'set the properties passed into the method
    objNewMember.Position = mIndex
    If Caption = "-" Then
        objNewMember.isSeparator = True
    Else
        objNewMember.Caption = Caption
    End If
    objNewMember.ID = ID
    mCol.Add objNewMember

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function

'remove all items from the collection
Public Sub Clear()
    mIndex = 0
    Dim i As Integer
    For i = mCol.Count To 1 Step -1
        mCol.Remove i
    Next i
End Sub

Public Property Get Item(vntIndexKey As Variant) As clsMenuItem
Attribute Item.VB_UserMemId = 0
  Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'create the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'destroy collection when this class is terminated
    Set mCol = Nothing
End Sub

