VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSpellCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'   - clsSpellCheck.cls
'
'   Copyright (C) 2005  William Moeur
'   This program is free software; you can redistribute it and/or modify it
'
'Methods:
'   GetSpellingErrors(RTB As RichTextBox) As Integer - Checks the spelling in
'       all the text in the RTB and returns the number of spelling errors
'       found.  Highlights all spelling errors.  A right-click on any error
'       brings up a popup menu with suggested changes.  If user selects a
'       change then the replacement is made.
'
'   ClearSpelling - Ignores all the highlighted spelling errors
'
'   Uses:
'       clsSubClass
'       clsMenu
'
'Note:
'   you must add a reference to the Microsoft Office Object Library to use
'       this class
'
Dim WordApp As Word.Application
Dim WordDoc As Word.Document

Private KillBillv2 As Boolean
Private nERRors As Integer

Private MisSpellings As Collection

Private WithEvents FormSubClass As clsSubClass
Attribute FormSubClass.VB_VarHelpID = -1
Private Popup As clsMenu

Private mRTB As RichTextBox

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Const EM_GETLINE = &HC4
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_LINELENGTH = &HC1
Private Const EM_LINEINDEX = &HBB



Private Const WM_NOTIFY = &H4E
Private Const WM_COMMAND = &H111

Private Const WM_USER = &H400
Private Const EM_SETCHARFORMAT = (WM_USER + 68)
Private Const EM_GETCHARFORMAT = (WM_USER + 58)
Private Const EM_SETEVENTMASK = (WM_USER + 69)
Private Const EM_AUTOURLDETECT As Long = (WM_USER + 91)

Private Const EN_LINK = &H70B
Private Const ENM_LINK = &H4000000
Private Const ENM_CHANGE = 1


Private Const LF_FACESIZE = 32
Private Type CharFormat
    cbSize As Long
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(LF_FACESIZE - 1) As Byte
End Type



Private Type CharRange
  cpMin As Long     ' First character of range (0 for start of doc)
  cpMax As Long     ' Last character of range (-1 for end of doc)
End Type

Private Type nmhdr
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

Private Type ENLINK
    nmhdr As nmhdr
    Msg As Long
    wParam As Long
    lParam As Long
    chrg As CharRange
End Type

'' CHARFORMAT masks
Private Const CFM_BOLD = &H1
Private Const CFM_ITALIC = &H2
Private Const CFM_UNDERLINE = &H4
Private Const CFM_STRIKEOUT = &H8
Private Const CFM_PROTECTED = &H10
Private Const CFM_LINK = &H20
Private Const CFM_SIZE = &H80000000
Private Const CFM_COLOR = &H40000000
Private Const CFM_FACE = &H20000000
Private Const CFM_OFFSET = &H10000000
Private Const CFM_CHARSET = &H8000000
Private Const CFM_UNDERLINETYPE = &H800000
Private Const CFM_REVAUTHOR = &H8000
Private Const CFM_LCID = &H2000000

' CHARFORMAT effects
Private Const CFE_BOLD = &H1
Private Const CFE_ITALIC = &H2
Private Const CFE_UNDERLINE = &H4
Private Const CFE_STRIKEOUT = &H8
Private Const CFE_PROTECTED = &H10
Private Const CFE_LINK = &H20
Private Const CFE_AUTOCOLOR = &H40000000

Private Const SCF_SELECTION = &H1
Private Const SCF_WORD = &H2
Private Const SCF_ALL = 4

Private Const CFU_UNDERLINEDOTTED = 4
Private Const CFU_UNDERLINEDOUBLE = 3
Private Const WM_RBUTTONUP = &H205

Private Type CHARFORMAT2
    cbSize As Long
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(LF_FACESIZE - 1) As Byte
    wWeight As Integer
    sSpacing As Integer
    crBackColor As Long
    lcid As Long
    dwReserved As Long
    sStyle As Integer
    wKerning As Integer
    bUnderlineType As Byte
    bAnimation As Byte
    bRevAuthor As Byte
    bReserved1 As Byte
End Type
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Sub Class_Initialize()
    Set FormSubClass = New clsSubClass
    Set Popup = New clsMenu
    Set MisSpellings = New Collection
    
End Sub

Private Sub Class_Terminate()
    Set mRTB = Nothing
    FormSubClass.Unsubclass
    StopMSWord
End Sub

'subclass the parent of the RTB to receive EN_LINK notifications
Private Sub FormSubClass_WMArrival(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, lRetVal As Long)
Dim notifyCode As nmhdr
Dim LinkData As ENLINK
Dim chars As CharRange
Dim FormatData As CHARFORMAT2
Dim lpRect As RECT
Dim clientRECT As RECT
Dim X As Long, Y As Long
Dim xWidth As Long, yHeight As Long
Dim Index As Integer

    Select Case uMsg
    
    Case WM_NOTIFY

        CopyMemory notifyCode, ByVal lParam, LenB(notifyCode)
        If notifyCode.code = EN_LINK Then
            CopyMemory LinkData, ByVal lParam, Len(LinkData)
            If LinkData.Msg = WM_RBUTTONUP Then
                'character range
                mRTB.SelStart = LinkData.chrg.cpMin
                mRTB.SelLength = LinkData.chrg.cpMax - LinkData.chrg.cpMin
                'get id of spelling error
                'show popup menu of spelling suggestions
                FormatData.cbSize = LenB(FormatData)
                SendMessage mRTB.hwnd, EM_GETCHARFORMAT, SCF_SELECTION, FormatData
                
                'get client coordinates of cursor
                Y = LinkData.lParam \ &H10000
                X = LinkData.lParam And &HFFFF&
                'convert to screen coordinates
                Call GetWindowRect(hwnd, lpRect)
                Call GetClientRect(hwnd, clientRECT)
                'get border widths
                xWidth = (lpRect.Right - lpRect.Left - clientRECT.Right) \ 2
                yHeight = lpRect.Bottom - lpRect.Top - clientRECT.Bottom - xWidth
                
                X = X + lpRect.Left + xWidth
                Y = Y + lpRect.Top + yHeight
                
                ReplaceSpellingError ShowSuggestions(FormatData.bRevAuthor, X, Y)

            'need to remove spelling error from list
                MisSpellings.Remove CStr(FormatData.bRevAuthor)
            'when no more errors are left, need to turn off subclassing
                If MisSpellings.Count = 0 Then ClearSpelling
            End If

        End If
        lRetVal = FormSubClass.callWindProc(hwnd, uMsg, wParam, lParam)
        
    Case Else
        lRetVal = FormSubClass.callWindProc(hwnd, uMsg, wParam, lParam)
    End Select

End Sub

Public Function GetSpellingErrors(RTB As RichTextBox) As Integer
    Dim strText As String
    Dim spError As Range
    Dim iPos As Long
    Dim i As Long
    Dim rngRange As Word.Range
    Dim myFormat As CHARFORMAT2
    Dim MS As Word.SpellingSuggestions
    Set mRTB = RTB
    
    
    'get all the text in the rtb
    strText = mRTB.Text
    
    'it may take some time to start word
    Screen.MousePointer = vbHourglass
    
    StartMSWord 'set module level variable WordApp
    GetMSWordDoc 'set module level variable WordDoc
    
    Set rngRange = WordApp.ActiveDocument.Range
    rngRange.InsertAfter strText
    
    'clear previous array
    For i = MisSpellings.Count To 1 Step -1
        MisSpellings.Remove i
    Next i
    'For i = 1 To nERRors
    '    Set misSpellings(i).ListOfAlternateWords = Nothing
    'Next i
    
    'get collection of spelling errors (1 to count)
    nERRors = WordDoc.SpellingErrors.Count
    GetSpellingErrors = nERRors
        
   If nERRors > 0 Then
    'ReDim misSpellings(1 To nERRors)
    i = 1
    iPos = -1
    'find each misspelling in the document
    For Each spError In WordDoc.SpellingErrors
        iPos = mRTB.Find(spError, iPos + 1, , rtfWholeWord Or rtfMatchCase)
        mRTB.SelStart = iPos
        mRTB.SelLength = Len(spError)
        'With misSpellings(i)
        '    .ilength = mRTB.SelLength
        '    .lColor = mRTB.SelColor
        '    .lStart = mRTB.SelStart
        '    .strWord = spError.Text
        '    Set .ListOfAlternateWords = WordApp.GetSpellingSuggestions(spError.Text)
        'End With
        Set MS = WordApp.GetSpellingSuggestions(spError.Text)
        MisSpellings.Add MS, CStr(i)
        Set MS = Nothing
        'set the link effect for misspelled word
        'this changes the format to underlined and blue like a hyperlink
        'it also fires off a WM_NOTIFY message to the RTB Parent for certain
        'mouse actions over the highlighted words
        'store the index of the spelling error in the revision author spot
        'Can't seem to change the lcid
        'however, if I don't include CFM_LCID in the mask then formatting gets
        'all messed up, backcolor goes to black
        With myFormat
            .cbSize = LenB(myFormat)
            .dwEffects = CFE_LINK
            .dwMask = CFM_REVAUTHOR + CFM_LCID + CFM_LINK
            .bRevAuthor = i
            '.lcid = i 'it won't let me change this
        End With
        SendMessage mRTB.hwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, myFormat
        i = i + 1
    Next
  End If
    
    'subclass form to get user selection of misspelled word
    FormSubClass.Enable mRTB.Parent.hwnd
    'set RTB to notify parent when user has clicked misspelled word
    SendMessage mRTB.hwnd, EM_SETEVENTMASK, 0&, ByVal ENM_LINK
  
  Screen.MousePointer = vbNormal
End Function
Private Function GetSuggestions(Index As Byte, Suggestions() As String) As Integer
Dim j As Integer
'fills the array with spelling suggestions for the misspelled word
'identified by Index.  Returns number of suggestions
    With MisSpellings.Item(CStr(Index))
        If .Count = 0 Then
            GetSuggestions = 1
            Suggestions(1) = "(no suggestions)"
        Else
            GetSuggestions = .Count
        End If
        For j = 1 To .Count
            Suggestions(j) = .Item(j).Name
        Next j
    End With
End Function

Private Sub StartMSWord()
'need to do something for those poor people who don't have MSword

    If WordApp Is Nothing Then 'if already set then ignore
        'Thanks RobDog888 for this
        On Error Resume Next
        Set WordApp = GetObject(, "Word.Application")
        On Error GoTo 0
        'is word already running?
        If TypeName(WordApp) = "Nothing" Then 'no then start it
            Set WordApp = CreateObject("Word.Application")
            'make sure we end word after we're finished
            KillBillv2 = True
        End If
    End If
End Sub

Private Sub StopMSWord()
'close word
    If KillBillv2 Then
        WordApp.Quit False
        KillBillv2 = False
    End If
    Set WordApp = Nothing
    Set WordDoc = Nothing
End Sub

Public Sub ClearSpelling()
Dim myFormat As CHARFORMAT2
    If mRTB Is Nothing Then Exit Sub
        With myFormat
            .cbSize = LenB(myFormat)
            .dwEffects = 0
            .dwMask = CFM_REVAUTHOR + CFM_LCID + CFM_LINK
            .bRevAuthor = 0
        End With
        SendMessage mRTB.hwnd, EM_SETCHARFORMAT, SCF_ALL, myFormat
        Set WordApp = Nothing
        Set WordDoc = Nothing
        FormSubClass.Unsubclass
End Sub

Private Sub GetMSWordDoc()
    
    If WordDoc Is Nothing Then
        'Thanks RobDog888 for this
        Select Case WordApp.Version
        Case "9.0", "10.0", "11.0"
            Set WordDoc = WordApp.Documents.Add(, , 1, True)
        Case "8.0"
            Set WordDoc = WordApp.Documents.Add
        Case Else
            MsgBox "Unsupported Version of Word.", vbOKOnly + _
                vbExclamation, "Spell Checker Class"
        End Select
    End If
End Sub

'Forms a popup menu that will allow the user to select one of the
'replacement spelling suggestions
Private Function ShowSuggestions(Index As Byte, X As Long, Y As Long) As String
Dim i As Long, iLast As Integer
Dim Suggestions(1 To 100) As String
Dim spellindex As Integer

    'clear any previous menu items
    Popup.Clear
    
    'get suggestions for current word
    iLast = GetSuggestions(Index, Suggestions)
        
    'first two menu items are always the same
    Popup.Add "Ignore", 0
    Popup.Add "-"
    'add suggestions to the popup menu
    For i = 1 To iLast
        Popup.Add Suggestions(i), i
    Next i

    'show popup menu of spelling suggestions
    'returns index of item selected
    spellindex = Popup.ShowMenu(mRTB.hwnd, X, Y)
    If spellindex = 0 Then 'Ignore selected
        ShowSuggestions = ""
    Else
        ShowSuggestions = Suggestions(spellindex)
    End If
        
End Function

'Replaces the selection in the RTB with the string passed in
'also clears special formatting from the new word
Private Sub ReplaceSpellingError(Selection As String)
Dim myFormat As CHARFORMAT2
'misspelled word should be selected at this point
    'Clear formatting on word
            With myFormat
            .cbSize = LenB(myFormat)
            .dwEffects = 0
            .dwMask = CFM_REVAUTHOR + CFM_LCID + CFM_LINK
            .bRevAuthor = 0
            '.lcid = i 'it won't let me change this
        End With
        SendMessage mRTB.hwnd, EM_SETCHARFORMAT, SCF_SELECTION + SCF_WORD, myFormat

    'replace with user's choice
    If Len(Selection) > 0 Then
        mRTB.SelText = Selection
    Else
        mRTB.SelLength = 0
    End If
    
End Sub


